#pragma warning(disable: 4819)
//#pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")


#include <stdio.h>
#include "cv.h"
#include "cxcore.h"
#include "highgui.h"

#define PIXVAL(iplimagep, x, y) (*(uchar *)((iplimagep)->imageData + (y) * (iplimagep)->widthStep + (x)))

#define QPC(cnloop, i) QueryPerformanceCounter(&(cnloop)[i]);
#define LOOP_MAX 100
#define CN_MAX 2
LARGE_INTEGER freq;
LARGE_INTEGER cn[LOOP_MAX][CN_MAX];

int main()
{
	int i, j;
	int loop = 0;
	IplImage *frame, *buf, *img, *back, *diff;

	CvCapture *capture = cvCaptureFromCAM(0);

	if (!capture) {
		fprintf(stderr, "cannot capture\n");
		return 1;
	}

	frame = cvQueryFrame(capture);
	buf = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 3);  // color
	img = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 1);
	back = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 1);
	diff = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 1);

	if (QueryPerformanceFrequency(&freq) == 0) {
		fprintf(stderr, "cannot use performance counter\n");
		return 1;
	}

	cvNamedWindow("image", CV_WINDOW_AUTOSIZE);
	cvNamedWindow("result", CV_WINDOW_AUTOSIZE);

	for (loop = 0; loop < LOOP_MAX; loop++) {

		frame = cvQueryFrame(capture); /* cannot be modified */

		cvFlip(frame, buf, NULL);
		cvCvtColor(buf, img, CV_BGR2GRAY);

		QPC(cn[loop], 0);

		for (j = 0; j < img->height; j++) {
			for (i = 0; i < img->width; i++) {
				PIXVAL(diff, i, j) = (PIXVAL(img, i, j) - PIXVAL(back, i, j)) / 2 + 128;
			}
		}

		QPC(cn[loop], 1);

		cvCopy(img, back, 0);
		cvShowImage("image", buf);
		cvShowImage("result", diff);

		if (cvWaitKey(30) > 0) {
			break;
		}
	}

	for (i = 1; i < CN_MAX; i++) {
		double t = 0.0;
		for (j = 0; j < LOOP_MAX; j++) {
			t += (1000000.0 *
				(cn[(loop + j) % LOOP_MAX][i].QuadPart 
				- cn[(loop + j) % LOOP_MAX][i-1].QuadPart)) / freq.QuadPart;
		}
		printf("%02d-%02d: %f [us]\n", i, i - 1, t / LOOP_MAX);
	}

	return 0;
}
