#pragma warning(disable: 4819)
//#pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")


#include <stdio.h>
#include "cv.h"
#include "cxcore.h"
#include "highgui.h"

#define PIXVAL(iplimagep, x, y) (*(uchar *)((iplimagep)->imageData + (y) * (iplimagep)->widthStep + (x)))
#define PIXVAL3(iplimagep, x, y, chan) (*(uchar *)((iplimagep)->imageData + (y) * (iplimagep)->widthStep + 3 * (x) + (chan)))

#define QPC(cnloop, i) QueryPerformanceCounter(&(cnloop)[i]);
#define LOOP_MAX 100
#define CN_MAX 2
LARGE_INTEGER freq;
LARGE_INTEGER cn[LOOP_MAX][CN_MAX];

#define LOOP_UNIFY

int main()
{
	int i, j;
	int loop = 0;
    uchar r, g, b, pix;
	IplImage *frame, *buf, *img, *back, *diff;

	CvCapture *capture = cvCaptureFromCAM(0);

	if (!capture) {
		fprintf(stderr, "cannot capture\n");
		return 1;
	}

	frame = cvQueryFrame(capture);
	buf = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 3);  // color
	img = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 1);
	back = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 1);
	diff = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 1);

	if (QueryPerformanceFrequency(&freq) == 0) {
		fprintf(stderr, "cannot use performance counter\n");
		return 1;
	}

	cvNamedWindow("image", CV_WINDOW_AUTOSIZE);
	cvNamedWindow("result", CV_WINDOW_AUTOSIZE);

	for (loop = 0; loop < LOOP_MAX; loop++) {

		frame = cvQueryFrame(capture); /* cannot be modified */

		QPC(cn[loop], 0);

#ifdef LOOP_UNIFY
		for (j = 0; j < img->height; j++) {
			for (i = 0; i < img->width; i++) {
				b = PIXVAL3(frame, i, img->height - j - 1, 0);
				g = PIXVAL3(frame, i, img->height - j - 1, 1);
				r = PIXVAL3(frame, i, img->height - j - 1, 2);

				pix = (r * 30 + g * 59 + b * 11) / 100;
				PIXVAL(diff, i, j) = (pix - PIXVAL(back, i, j)) / 2 + 128;
				PIXVAL(back, i, j) = pix;
			}
		}
#else
		// flip
		for (j = 0; j < img->height; j++) {
			for (i = 0; i < img->width; i++) {
				PIXVAL3(buf, i, j, 0) = PIXVAL3(frame, i, img->height - j - 1, 0);
				PIXVAL3(buf, i, j, 1) = PIXVAL3(frame, i, img->height - j - 1, 1);
				PIXVAL3(buf, i, j, 2) = PIXVAL3(frame, i, img->height - j - 1, 2);
			}
		}

		// CvtColor
		for (j = 0; j < img->height; j++) {
			for (i = 0; i < img->width; i++) {
				PIXVAL(img, i, j) = (PIXVAL3(buf, i, j, 2) * 30 + PIXVAL3(buf, i, j, 1) * 59 + 
					PIXVAL3(buf, i, j, 0) * 11) / 100;
			}
		}

		for (j = 0; j < img->height; j++) {
			for (i = 0; i < img->width; i++) {
				PIXVAL(diff, i, j) = (PIXVAL(img, i, j) - PIXVAL(back, i, j)) / 2 + 128;
			}
		}

		// copy img to back
		for (j = 0; j < img->height; j++) {
			for (i = 0; i < img->width; i++) {
				PIXVAL(back, i, j) = PIXVAL(img, i, j);
			}
		}
#endif

		QPC(cn[loop], 1);

		cvShowImage("image", back);
		cvShowImage("result", diff);

		if (cvWaitKey(30) > 0) {
			break;
		}
	}

	for (i = 1; i < CN_MAX; i++) {
		double t = 0.0;
		for (j = 0; j < LOOP_MAX; j++) {
			t += (1000000.0 *
				(cn[(loop + j) % LOOP_MAX][i].QuadPart 
				- cn[(loop + j) % LOOP_MAX][i-1].QuadPart)) / freq.QuadPart;
		}
		printf("%02d-%02d: %f [us]\n", i, i - 1, t / LOOP_MAX);
	}

	return 0;
}
